%% Loading .mat Files

load('Q2_i_Received_Flat.mat')
load('Q2_i_Transmitted_Flat.mat')
load('Q2_i_Received_Frequency_Selective.mat')
load('Q2_i_Transmitted_Frequency_Selective.mat')

Received_Flat = Received_Flat.';
Transmitted_Flat = Transmitted_Flat.';
Transmitted_Frequency_Selective = Transmitted_Frequency_Selective.';
Received_Frequency_Selective = Received_Frequency_Selective.';
%% Plotting Constellation Diagram and PSD Plot
% This code is from zvisualizer function
SampleRate = 30.72e6;
hScope = comm.ConstellationDiagram('SymbolsToDisplay',...
256, 'ShowReferenceConstellation', false,...
'YLimits', [-2 2], 'XLimits', [-2 2], 'Position', ...
figposition([5 60 20 25]), 'Name', 'Constellation Of signal after FreqFlatChannel');

hScope(Received_Flat)
hSpecAnalyzer = dsp.SpectrumAnalyzer('SampleRate', SampleRate, ...
'SpectrumType', 'Power', 'PowerUnits', 'dBm', ...
'RBWSource', 'Property', 'RBW', 15000,'NumInputPorts',2,...
'FrequencySpan', 'Span and center frequency',...
'Span', 20e6, 'CenterFrequency', 0,...
'FFTLengthSource', 'Property', 'FFTLength',2048,...
'Title', 'Transmitted  Signal Spectrum before and after Frequency Flat Fading Channel', 'YLimits', [-50 50],...
'YLabel', 'PSD');
hSpecAnalyzer(Transmitted_Flat,Received_Flat)

hSpecAnalyzer1 = dsp.SpectrumAnalyzer('SampleRate', SampleRate, ...
'SpectrumType', 'Power', 'PowerUnits', 'dBm', ...
'RBWSource', 'Property', 'RBW', 15000,'NumInputPorts',2,...
'FrequencySpan', 'Span and center frequency',...
'Span', 20e6, 'CenterFrequency', 0,...
'FFTLengthSource', 'Property', 'FFTLength',2048,...
'Title', 'Transmitted  Signal Spectrum before and after Frequency Selective Channel', 'YLimits', [-50 50],...
'YLabel', 'PSD');
hScope1 = comm.ConstellationDiagram('SymbolsToDisplay',...
256, 'ShowReferenceConstellation', false,...
'YLimits', [-2 2], 'XLimits', [-2 2], 'Position', ...
figposition([5 60 20 25]), 'Name', 'Constellation Of signal after Channel');
hScope1(Received_Frequency_Selective)
hSpecAnalyzer1(Transmitted_Frequency_Selective,Received_Frequency_Selective)
